"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _nodemailer = _interopRequireDefault(require("nodemailer"));

var _logger = _interopRequireDefault(require("../lib/logger"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _default = options => {
  return _objectSpread({
    id: 'email',
    type: 'email',
    name: 'Email',
    server: {
      host: 'localhost',
      port: 25,
      auth: {
        user: '',
        pass: ''
      }
    },
    from: 'NextAuth <no-reply@example.com>',
    maxAge: 24 * 60 * 60,
    sendVerificationRequest
  }, options);
};

exports.default = _default;

var sendVerificationRequest = (_ref) => {
  var {
    identifier: emailAddress,
    url,
    token,
    site,
    provider
  } = _ref;
  return new Promise((resolve, reject) => {
    var {
      server,
      from
    } = provider;
    var siteName = site.replace(/^https?:\/\//, '');

    _nodemailer.default.createTransport(server).sendMail({
      to: emailAddress,
      from,
      subject: "Sign in to ".concat(siteName),
      text: text({
        url,
        siteName
      }),
      html: html({
        url,
        siteName
      })
    }, error => {
      if (error) {
        _logger.default.error('SEND_VERIFICATION_EMAIL_ERROR', emailAddress, error);

        return reject(new Error('SEND_VERIFICATION_EMAIL_ERROR', error));
      }

      return resolve();
    });
  });
};

var html = (_ref2) => {
  var {
    url,
    siteName
  } = _ref2;
  var buttonBackgroundColor = '#444444';
  var buttonTextColor = '#ffffff';
  return "\n<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n  <tr>\n    <td align=\"center\" style=\"padding: 8px 0; font-size: 22px; font-family: Helvetica, Arial, sans-serif; color: #888888;\">\n       ".concat(siteName, "\n    </td>\n  </tr>\n  <tr>\n    <td align=\"center\" style=\"padding: 16px 0;\">\n      <table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n        <tr>\n          <td align=\"center\" style=\"border-radius: 3px;\" bgcolor=\"").concat(buttonBackgroundColor, "\"><a href=\"").concat(url, "\" target=\"_blank\" style=\"font-size: 18px; font-family: Helvetica, Arial, sans-serif; color: ").concat(buttonTextColor, "; text-decoration: none; text-decoration: none;border-radius: 3px; padding: 12px 18px; border: 1px solid ").concat(buttonBackgroundColor, "; display: inline-block; font-weight: bold;\">Sign in</a></td>\n        </tr>\n      </table>\n    </td>\n  </tr>\n</table>\n");
};

var text = (_ref3) => {
  var {
    url,
    siteName
  } = _ref3;
  return "Sign in to ".concat(siteName, "\n").concat(url, "\n\n");
};